// CTVItemDataMgrTree.cpp : Tree Control operations for CTVItemDataMgr class
//

#include "stdafx.h"
#include "TVItemData.h"
#include "TVItemDataMgr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// Recursive method
HRESULT	CTVItemDataMgr::InsertTreeNode( CTreeCtrl& ctrTree,
                                          const LONG lParentNode,
                                          HTREEITEM hParentItem,
                                          BOOL& bExpand )
{
	HRESULT hr = S_OK;

   TVINSERTSTRUCT tvis;
   tvis.hParent = hParentItem;
   tvis.hInsertAfter = TVI_LAST;

   CWaitCursor wait;

	std::pair<CTVItemDataMMap::iterator, CTVItemDataMMap::iterator>
      p = m_TVItemDataMMap.equal_range( lParentNode );

	for(CTVItemDataMMap::iterator It = p.first; It != p.second; It++)
	{
      bExpand = TRUE;

      CTVItemData& rTVItemData = (It->second);

      TVITEM tvItem;

      tvItem.mask = LVIF_TEXT | LVIF_PARAM;

      // Virtual Tree control (set pszText to callback and max item length)
      tvItem.pszText		= LPSTR_TEXTCALLBACK;
		tvItem.cchTextMax	= MAX_ITEMLEN;
		tvItem.lParam		= reinterpret_cast<LPARAM>( &rTVItemData );

      tvis.item = tvItem;

      HTREEITEM hChild = ctrTree.InsertItem( &tvis );

      BOOL bExpandTree = FALSE;
		InsertTreeNode(ctrTree, rTVItemData.GetID( ), hChild, bExpandTree );

		if( bExpandTree )
      {
         ctrTree.Expand( hChild, TVE_EXPAND );
      }

      // Pump messages to allow cancel button click
      // during control filling.  Populating the control
      // with thousands of records takes time, so we need
      // to process messages to handle the cancel button
      // and close messages
      if(!ProcessMessages( ))
      {
         return hr;
      }

      // Restore the wait cursor
      // (if you don't do this, the wait cursor may go
      // away after processing messages)
      wait.Restore();

		// Check if user cancelled operation
		if( WAIT_OBJECT_0 == WaitForSingleObject( GetShutdownEvent(), 0 ) )
      {
         return hr;
      }
	}

	return hr;
}